/* definitions for keyboard macros */

#ifndef	MACRO_H
#define MACRO_H

#ifndef	LIST_H
#include "list.h"
#endif

/*
 * For GNU comptability and to allow for searches, extended commands and
 * other goodies in macros, macros _must_ be a string of keystrokes, nothing
 * more.
 */
struct macro {
	struct list     m_list;	/* List of macros in use */
	KCHAR          *m_text;	/* The entire text */
	KCHAR          *m_cur;	/* What's left in execution */
	int             m_max;	/* space we have total/execution count */
	int             m_count;/* space used so far */
};
#define	m_name	m_list.l_name
#define	m_macp	m_list.l_p.l_mp

extern struct macro *inmacro;
extern int      macrodef;

extern void add_key_to_macro 
PROTO((KCHAR, struct macro *));
extern void add_string_to_macro 
PROTO((char *, struct macro *));
extern int runmacro 
PROTO((struct macro *, int, int, int));
extern struct macro *find_macro 
PROTO((char *));
extern VOID restore_macro 
PROTO((VOID));
extern int sinsert 
PROTO((register char *s));
#endif
